<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class OpeningBlock extends Record {
    private $logon;
    private $password;
    private $blank;

    public function __construct($logon, $password) {
        $this->setValues($logon, $password);
        $this->setColumns();
    }

    private function setValues($logon, $password) {
        $this->logon = $logon;
        $this->password = $password;
        $this->blank = "";
    }

    private function setColumns() {
        $this->setColumn("logon", new RecordColumn($this->logon, RecordColumn::TYPE_ALPHANUMERIC, 1, 8));
        $this->setColumn("password", new RecordColumn($this->password, RecordColumn::TYPE_ALPHANUMERIC, 1, 8));
        $this->setColumn("blank", new RecordColumn($this->blank, RecordColumn::TYPE_ALPHANUMERIC, 1, 8));
    }
}