<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegB001 extends Record {
    protected $templateColumns =  [
        [
            "name" => "type_rule",
            "position" => "1",
            "size" => "4",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "spelling",
            "position" => "5",
            "size" => "45",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "cpf",
            "position" => "50",
            "size" => "11",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "rg",
            "position" => "61",
            "size" => "15",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "birthdate",
            "position" => "76",
            "size" => "8",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "city_code",
            "position" => "84",
            "size" => "4",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "holder",
            "position" => "88",
            "size" => "1",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "ccf_ind",
            "position" => "89",
            "size" => "1",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "filler_1",
            "position" => "90",
            "size" => "3",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "linik_n",
            "position" => "93",
            "size" => "9",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "old_situation",
            "position" => "102",
            "size" => "1",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "current_date",
            "position" => "103",
            "size" => "8",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "reserved",
            "position" => "111",
            "size" => "1",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "indic_error",
            "position" => "112",
            "size" => "1",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "exclude_spelling",
            "position" => "113",
            "size" => "1",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            "name" => "new_situation",
            "position" => "114",
            "size" => "1",
            "type" => RecordColumn::TYPE_NUMERIC,
        ],
        [
            "name" => "filler_2",
            "position" => "115",
            "size" => "1",
            "type" => RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];
    

    public function __construct($values = null) {
        $this->createColumns();
    }


}