<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPRD_0;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPRD_1;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeAL05;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPDC_1;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPDC_2;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPDC_3;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPDC_4;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPPG_0;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPPG_1;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPTM_0;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPTM_1;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPIR_0;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeBPIR_1;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeRMF6;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_0;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_1;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_2;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_3;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_4;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_5;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_6;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_7;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeSPF3_8;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeCAFI_0;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeCAFI_1;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeCAFI_2;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeMSM3_0;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900\SubTypeMSM3_1;

class RegF900 extends Record {
    protected $templateColumns = null;

    protected $subType;

    public function __construct($values = null) {
        
    }

    public function getSubType($recordString) {
        $subtype = substr($recordString, 4, 4);
        switch($subtype) {
            case 'BPRD':
                switch((int)(substr($recordString, 8, 1))) {
                    case 0:
                        return SubTypeBPRD_0::class;
                    case 1:
                        return SubTypeBPRD_1::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            case 'AL05':
                return SubTypeAL05::class;
            case 'BPDC':
                switch((int)(substr($recordString, 8, 3))) {
                    case 1:
                        return SubTypeBPDC_1::class;
                    case 2:
                        return SubTypeBPDC_2::class;
                    case 3:
                        return SubTypeBPDC_3::class;
                    case 4:
                        return SubTypeBPDC_4::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            case 'BPPG':
                switch((int)(substr($recordString, 8, 1))) {
                    case 0:
                        return SubTypeBPPG_0::class;
                    case 1:
                        return SubTypeBPPG_1::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            case 'BPTM':
                switch((int)(substr($recordString, 8, 1))) {
                    case 0:
                        return SubTypeBPTM_0::class;
                    case 1:
                        return SubTypeBPTM_1::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            case 'BPIR':
                switch((int)(substr($recordString, 8, 1))) {
                    case 0:
                        return SubTypeBPIR_0::class;
                    case 1:
                        return SubTypeBPIR_1::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            case 'RMF6':
                return SubTypeRMF6::class;
            case 'SPF3':
                switch((int)(substr($recordString, 8, 3))) {
                    case 0:
                        return SubTypeSPF3_0::class;
                    case 1:
                        return SubTypeSPF3_1::class;
                    case 2:
                        return SubTypeSPF3_2::class;
                    case 3:
                        return SubTypeSPF3_3::class;
                    case 4:
                        return SubTypeSPF3_4::class;
                    case 5:
                        return SubTypeSPF3_5::class;
                    case 6:
                        return SubTypeSPF3_6::class;
                    case 7:
                        return SubTypeSPF3_7::class;
                    case 8:
                        return SubTypeSPF3_8::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            case 'CAFI':
                switch((int)(substr($recordString, 8, 1))) {
                    case 0:
                        return SubTypeCAFI_0::class;
                    case 1:
                        return SubTypeCAFI_1::class;
                    case 2:
                        return SubTypeCAFI_2::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            case 'MSM3':
                switch((int)(substr($recordString, 8, 1))) {
                    case 0:
                        return SubTypeMSM3_0::class;
                    case 1:
                        return SubTypeMSM3_1::class;
                    default:
                        throw new \Exception("Subtipo não existe para o bloco 'F900'");
                }
            default: 
                throw new \Exception("Subtipo '$subtype' não existe para o bloco 'F900'");
        }

    }

    public function load($recordString) {

        $subTypeClass = $this->getSubType($recordString);
        $this->subType = new $subTypeClass();

        $this->templateColumns = $this->subType->templateColumns;

        $this->createColumns();
        parent::load($recordString);
    }

    public function getValues() {
        $subType = $this->subType;
        $values = parent::getValues();
        $values['name'] = $subType->name;

        return  $values;
    }
}