<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Subtypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeSPF3_7 {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "code_feature",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type",
            'position' => 9,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "total_amount",
            'position' => 12,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "current_date",
            'position' => 15,
            'size' => 6,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "current_amount",
            'position' => 21,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "amount_month_1",
            'position' => 24,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "amount_month_2",
            'position' => 27,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "amount_month_3",
            'position' => 30,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "amount_month_4",
            'position' => 33,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "amount_month_5",
            'position' => 36,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "amount_month_6",
            'position' => 39,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler_1",
            'position' => 42,
            'size' => 74,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];
}