<?php 

namespace Schaffen\SerasaRemessa\Http\Basic;
use GuzzleHttp\Client;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\ClosingBlock;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\MainBlock;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\OpeningBlock;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\RegN001;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\RegN003;
use Schaffen\SerasaRemessa\Http\Basic\Blocks\RegP002;

class Query {
    private $mainBlock;
    private $regP002;
    private $regN001;
    private $regN003;
    private $closingBlock;
    private $openingBlock;

    public function __construct($logon, $password, array $config) {
        $this->openingBlock = new OpeningBlock($logon, $password);
        $this->mainBlock = new MainBlock($config);
        $this->regP002 = new RegP002([]);
        $this->regN001 = new RegN001([]);
        $this->regN003 = new RegN003([]);
        $this->closingBlock = new ClosingBlock();
    }

    private function makeOpeningBlock() {
        return $this->openingBlock->toString();
    }
    private function makeMainBlock() {
        return $this->mainBlock->toString();
    }
    
    private function makeRegP002() {
        return $this->regP002->toString();
    }

    private function makeRegN001() {
        return $this->regN001->toString();
    }

    private function makeRegN003() {
        return $this->regN003->toString();
    }

    private function makeClosingBlock() {
        return $this->closingBlock->toString();
    }

    public function make() {
        $openingBlock = $this->makeOpeningBlock();
        $mainBlock = $this->makeMainBlock();
        $regP002 = $this->makeRegP002();
        $regN001 = $this->makeRegN001();
        $regN003 = $this->makeRegN003();
        $closingBlock = $this->makeClosingBlock();
        
        return $openingBlock . $mainBlock . $regP002 . $regN001 . $regN003 . $closingBlock;
    }

    public function send($url) {
        try {
            $p = $this->make();
            dd($p);

            $client = new Client();
            $body = $client->request('POST', $url, ['query' => ['p' => $p]])->getBody();
            echo $body;
            die();
            $response = Response::load($body);
            
            dd($response);
        } catch(Exception $e) {
            dd($e->getResponse()->getBody()->getContents());
        }
    }
}