<?php

namespace Schaffen\SerasaRemessa\Utils;

class RecordColumn {


    const TYPE_ALPHABETICAL = 'A';
    const TYPE_NUMERIC = 'N';
    const TYPE_ALPHANUMERIC = 'X';


    private $type;
    private $position;
    private $size;
    private $value;

    public function __construct($value, $type, $position, $size){
        $this->value = $value;
        $this->type = $type;
        $this->size = $size;
        $this->position = $position;
    }

    public function setValue($value) {
        if($this->value === null) {
            $this->value = $value;
        }
    }

    public function getFormatedValue() {
        return Util::formatCnab($this->type, $this->value, $this->size);
    }

    public function getRest() {
        return substr(Util::upper(Util::normalizeChars($this->value)), $this->size);
    }

    public function getValue() {
        return $this->value;
    }
}